#ifndef _nvram_h_
#define _nvram_h_

#define NVRAM_MAGIC		0x48534C46	/* 'FLASH' */
#define NVRAM_SPACE             0x40000  	// 128K

//IOCTL
#define NVRAM_FREE		0x10
#define NVRAM_2FILE		0x20

int nvram_init(void *unused);
int nvram_close();
char *nvram_get(const char *name);
int nvram_listall(FILE *fp);
int nvram_free();
int nvram_set(const char *name, const char *value);
int nvram_unset(const char *name);
int file2nvram(char *filename);
int nvram2file(char *filename);
char *nvram_get_index(const char *name, int index);
int nvram_set_index(const char *name, int index, const char *value);
static inline int nvram_match(const char *name, const char *value)
{
    return (strcmp(nvram_get(name), value));
}
#define nvram_safe_get(name) (nvram_get(name) ? : "")
#define nvram_safe_get_index(name,index) (nvram_get_index(name,index) ? : "")

void setPidToNVRAM(const char *name, int id, int pid);
#endif /* _nvram_h_ */
