
/*
    _exception:
		mfc0	k0, C0_CAUSE
		li		k1, 0x28    	#ExcCode=10

		and		k0, k0, k1
		bne		k0, k1, 1f      #not ri_exception

		la		k0, tc3160_handle_ri
		jalr	k1, k0
		nop

    1:
    	mfc0    k0,C0_CAUSE
        li		k1,0xff00  #IP(7..0)
        and		k0,k0,k1
        bne		k0,zero,2f
        nop		
        mfc0	k0,C0_EPC
        nop
        j		k0			#return
        nop	
    
    2:    
*/
#include "ri_exception.h"
/*.section ".ri_exception", "ax"*/	
	.globl	tc3160_handle_ri
	.ent	tc3160_handle_ri
tc3160_handle_ri:
	subu	sp,sp, EXCFRAMESIZE
	
	SREG(zero,R_ZERO,sp)		/* $0  (zero) */
	.set noat
	SREG(AT,R_AT,sp)		/* $1  (AT) */
	.set at
	SREG(v0,R_V0,sp)		/* $2  (v0) */
	SREG(v1,R_V1,sp)		/* $3  (v1) */
	SREG(a0,R_A0,sp)		/* $4  (a0) */
	SREG(a1,R_A1,sp)		/* $5  (a1) */
	SREG(a2,R_A2,sp)		/* $6  (a2) */
	SREG(a3,R_A3,sp)		/* $7  (a3) */
	SREG(t0,R_T0,sp)		/* $8  (t0) */
	SREG(t1,R_T1,sp)		/* $9  (t1) */
	SREG(t2,R_T2,sp)		/* $10 (t2) */
	SREG(t3,R_T3,sp)		/* $11 (t3) */
	SREG(t4,R_T4,sp)		/* $12 (t4) */
	SREG(t5,R_T5,sp)		/* $13 (t5) */
	SREG(t6,R_T6,sp)		/* $14 (t6) */
	SREG(t7,R_T7,sp)		/* $15 (t7) */
	SREG(s0,R_S0,sp)		/* $16 (s0) */
	SREG(s1,R_S1,sp)		/* $17 (s1) */
	SREG(s2,R_S2,sp)		/* $18 (s2) */
	SREG(s3,R_S3,sp)		/* $19 (s3) */
	SREG(s4,R_S4,sp)		/* $20 (s4) */
	SREG(s5,R_S5,sp)		/* $21 (s5) */
	SREG(s6,R_S6,sp)		/* $22 (s6) */
	SREG(s7,R_S7,sp)		/* $23 (s7) */
	SREG(t8,R_T8,sp)		/* $24 (t8) */
	SREG(t9,R_T9,sp)		/* $25 (t9) */
#ifdef INSTRUMENT_RI_TRAPS
	SREG(k0,R_K0,sp)		/* $26 (k0) */
#endif
	SREG(k1,R_K1,sp)		/* $27 (k1) */
	SREG(gp,R_GP,sp)		/* $28 (gp) */
	SREG(sp,R_SP,sp)		/* $29 (sp) */
	SREG(s8,R_FP,sp)		/* $30 (s8) */
	SREG(ra,R_RA,sp)		/* $31 (ra) */
#if 0
	mfc0	t1,C0_PRID
	nop
	li	t2, 0xffff
	and	t1, t2, t1
	li	t2, PRID_LX4080P0
	bne	t1, t2, 1f
	/* Save emulated HI and LO registers */
	la	t1, emulatedHI
	lw	t1, 0(t1)
	nop
	SREG(t1,R_HI,sp)		/* Hi */

	la	t2, emulatedLO
	lw	t2, 0(t2)
	nop
	SREG(t2,R_LO,sp)		/* Lo */
	b	2f
#endif
1:	/* Save real HI and LO registers */
	mfhi	t1
	mflo	t2
	SREG(t1,R_HI,sp)		/* Hi */
	SREG(t2,R_LO,sp)		/* Lo */
2:	

	mfc0	t1,C0_CAUSE
	MFC0	t2,C0_EPC
	mfc0	t3,C0_SR
	SREG(t1,R_CAUSE,sp)		/* Cause */
	SREG(t2,R_EPC,sp)		/* EPC */

	# save the SR value but fixup the KU & IE bits to 
	# reflect their state before the exception
	li	t1,0x3f			# KU&IE mask
	and	t2,t3,t1		# extract KU&IE bits
	not	t1			# invert the mask
	and	t3,t1			# clear KU&IE field
	srl	t2,2			# fixup KU&IE field
	or	t3,t2			# insert the KU&IE field

	SREG(t3,R_STATUS,sp)		# save Status

	addiu	a0, sp, _STKFRM
	jal	emulate_tc3160_ri
	nop  /* add by aladdin */

	move	k0, v0

	# at restored later		/* $1  (at) */
	LREG(v0,R_V0,sp)		/* $2  (v0) */
	LREG(v1,R_V1,sp)		/* $3  (v1) */
	LREG(a0,R_A0,sp)		/* $4  (a0) */
	LREG(a1,R_A1,sp)		/* $5  (a1) */
	LREG(a2,R_A2,sp)		/* $6  (a2) */
	LREG(a3,R_A3,sp)		/* $7  (a3) */
	# t0 restored later		/* $8  (t0) */
	# t1 restored later		/* $9  (t1) */
	# t2 restored later		/* $10 (t2) */
	LREG(t3,R_T3,sp)		/* $11 (t3) */
	LREG(t4,R_T4,sp)		/* $12 (t4) */
	LREG(t5,R_T5,sp)		/* $13 (t5) */
	LREG(t6,R_T6,sp)		/* $14 (t6) */
	LREG(t7,R_T7,sp)		/* $15 (t7) */
	LREG(s0,R_S0,sp)		/* $16 (s0) */
	LREG(s1,R_S1,sp)		/* $17 (s1) */
	LREG(s2,R_S2,sp)		/* $18 (s2) */
	LREG(s3,R_S3,sp)		/* $19 (s3) */
	LREG(s4,R_S4,sp)		/* $20 (s4) */
	LREG(s5,R_S5,sp)		/* $21 (s5) */
	LREG(s6,R_S6,sp)		/* $22 (s6) */
	LREG(s7,R_S7,sp)		/* $23 (s7) */
	LREG(t8,R_T8,sp)		/* $24 (t8) */
	LREG(t9,R_T9,sp)		/* $25 (t9) */
	# k0 not restored		/* $26 (k0) */
	# k1 restored later		/* $27 (k1) */
	# gp restored later		/* $28 (gp) */
	LREG(sp,R_SP,sp)		/* $29 (sp) */
	LREG(s8,R_FP,sp)		/* $30 (s8) */
	LREG(ra,R_RA,sp)		/* $31 (ra) */
#if 0	
	mfc0	t1,C0_PRID
	nop
	li	t0, 0xffff
	and	t1, t0, t1
	li	t0, PRID_LX4080P0
	bne	t1, t0, 1f
	/* Restore emulated HI and LO registers */
	LREG(t0,R_HI,sp)		/* Hi */
	la	t1, emulatedHI
	sw	t0, 0(t1)
	
	LREG(t0,R_LO,sp)		/* Lo */
	la	t1, emulatedLO
	sw	t0, 0(t1)
	b	2f
#endif
1:	/* Restore real HI and LO registers */
	LREG(t0,R_HI,sp)		/* Hi */
	LREG(t1,R_LO,sp)		/* Lo */
	mthi	t0
	mtlo	t1
2:	

	# restore SR from Status but fixup the KU&IE field
	# to make sure that correct value is restored after the rfe
	mtc0	zero,C0_SR		# clear IEC (and everything else)
	# interrupts now off (k0 & k1 safe)
	LREG(t1,R_STATUS,sp)		# get Status
	.set noat
	li	AT,0x3f			# KU&IE mask
	and	t0,t1,AT		# get KU&IE field
	not	AT			# invert mask
	and	t1,AT			# clear KU&IE field
	sll	t0,2			# fixup KU&IE field
	or	t0,t1			# insert KU&IE field

	mtc0	t0,C0_SR

	LREG(t1,R_CAUSE,sp)		/* Cause - For Sw field only */
	LREG(t0,R_T0,sp)		/* $8  (t0) */
	LREG(t2,R_T2,sp)		/* $10 (t2) */
	mtc0	t1,C0_CAUSE
	LREG(AT,R_AT,sp)		/* $1  (AT) */
	LREG(t1,R_T1,sp)		/* $8  (t0) */
	LREG(k1,R_K1,sp)		/* $27 (k1) */
	LREG(gp,R_GP,sp)		/* $28 (gp) */
	
	bnez	k0, 1f
#ifdef INSTRUMENT_RI_TRAPS
	LREG(k0,R_K0,sp)		/* $26 (k0) */
#endif

	addu	sp, EXCFRAMESIZE

#ifdef INSTRUMENT_RI_TRAPS
	ctc3	k0, $0			/* restore counters  */
#endif

	j	k1			/* Return	*/

1:	LREG(k0,R_EPC,sp)		/* EPC */
#ifdef INSTRUMENT_RI_TRAPS
	LREG(k1,R_K0,sp)		/* Trashes k1 (return address) rfe uses k0 anyway.*/
#endif

	addu	sp, EXCFRAMESIZE

#ifdef INSTRUMENT_RI_TRAPS
	ctc3	k1, $0			/* restore counters  */
#endif

	.set noreorder
	j	k0			/* RI handled	*/
	rfe
	.set reorder
	.end	tc3160_handle_ri
