#include <linux/version.h>

#include <linux/console.h>
#include <linux/init.h>
#include <linux/interrupt.h>
#include <linux/sched.h>
#include <linux/kernel.h> /* oops_in_progress */
#include <asm/addrspace.h>
#include <asm/mipsregs.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/reboot.h>
#include <asm/time.h>
#include <asm/irq.h>
#include <asm/tc3162/interrupts.h>
#include <asm/tc3162/tc3162.h>

extern asmlinkage void tc3162_handle_int(void);
extern asmlinkage void handle_ri(void);
extern char except_vec3_generic;  /* for reserved instruction exception */

void tc3160_irq_init(void);

extern void (*board_time_init)(void);
extern void (*board_timer_setup)(struct irqaction *);
extern void tc3162_time_init(void);
extern void tc3162_time_setup(struct irqaction *);

/*
 * Information regarding the IRQ Controller
 */

extern void lexra_machine_restart(char *command);
extern void lexra_machine_halt(void);
extern void lexra_machine_power_off(void);

static void tc3162_component_setup(void)
{
}

void __init tc3162_setup(void)
{
	set_io_port_base(0);

#ifdef CONFIG_TRENDCHIP_TC3162
    tc3162_component_setup();

    board_time_init = tc3162_time_init;
    board_timer_setup = tc3162_time_setup;
#endif

    _machine_restart = lexra_machine_restart;
    _machine_halt = lexra_machine_halt;
    _machine_power_off = lexra_machine_power_off;

	/*  trap MAC instructions before trap_init is called in Linux kernel,
	it will be override later in trap_init */
	set_except_vector(10, handle_ri);
	memcpy((void *)(KSEG0 + 0x80), &except_vec3_generic, 0x80);
	flush_icache_range(KSEG0+0x80, KSEG0+0x80);
}

