/*  
 * Definitions used to for APB Bridge and DMA Controller Operation register.
 *
 * Written by Robert Wu, Billion Co.
 * Support for TrendChip TC3162
 */

#ifndef __TC3162_APBDMA_H__ 
#define __TC3162_APBDMA_H__ 

#include <asm/addrspace.h>

#define TC3162_APBDMA_BASE		(KSEG1 + 0x1FB30000)
#define TC3162_DCMA0_REG		(TC3162_APBDMA_BASE + 0x0)
#define TC3162_DCDA0_REG		(TC3162_APBDMA_BASE + 0x4)
#define TC3162_DCBT0_REG		(TC3162_APBDMA_BASE + 0x8)
#define TC3162_DCBL0_REG		(TC3162_APBDMA_BASE + 0xA)
#define TC3162_DCC0_REG			(TC3162_APBDMA_BASE + 0xC)
#define TC3162_DCS0_REG			(TC3162_APBDMA_BASE + 0xE)
#define TC3162_DCMA1_REG		(TC3162_APBDMA_BASE + 0x10)
#define TC3162_DCDA1_REG		(TC3162_APBDMA_BASE + 0x14)
#define TC3162_DCBT1_REG		(TC3162_APBDMA_BASE + 0x18)
#define TC3162_DCBL1_REG		(TC3162_APBDMA_BASE + 0x1A)
#define TC3162_DCC1_REG			(TC3162_APBDMA_BASE + 0x1C)
#define TC3162_DCS1_REG			(TC3162_APBDMA_BASE + 0x1E)


#ifndef __ASSEMBLY__
#endif /* !__ASSEMBLY__ */

#endif /* __TC3162_APBDMA_H__ */


