/*  
 * Definitions used to for GPIO Controller Operation register.
 *
 * Written by Robert Wu, Billion Co.
 * Support for TrendChip TC3162
 */


#ifndef __TC3162_GPIO_H__ 
#define __TC3162_GPIO_H__ 

#include <asm/addrspace.h>

#define TC3162_GPIO_BASE	(KSEG1 + 0x1FBF0200)
#define TC3162_GPCTL_REG	(TC3162_GPIO_BASE + 0x0) /* GPIO Control register */
#define TC3162_GPDATA_REG	(TC3162_GPIO_BASE + 0x4 + 0x2) /* GPIO Data register */
#define TC3162_GPINT_STATUS_REG	(TC3162_GPIO_BASE + 0x8 + 0x2) /* GPIO Interrupt Status register */
#define TC3162_GPINT_EDC_REG	(TC3162_GPIO_BASE + 0xC) /* GPIO Interrupt Edge Detect Control register */
#define TC3162_GPINT_LDC_REG	(TC3162_GPIO_BASE + 0x10)/* GPIO Interrupt Level Detect Control register */
#define TC3162_GPOPENDRAIN_REG	(TC3162_GPIO_BASE + 0x14 + 0x2)/* GPIO Open Drain Control register */
#define TC3162_GPLED_DP_REG	(TC3162_GPIO_BASE + 0x18 + 0x2)/* GPIO LED Display Period register */
#define TC3162_GPOUTPUT_LED_REG	(TC3162_GPIO_BASE + 0x1C)/* GPIO Output LED Display Control register */

#define GPIO_15 30
#define GPIO_14 28
#define GPIO_13 26
#define GPIO_12 24
#define GPIO_11 22
#define GPIO_10 20
#define GPIO_9 18
#define GPIO_8 16
#define GPIO_7 14
#define GPIO_6 12
#define GPIO_5 10
#define GPIO_4 8
#define GPIO_3 6
#define GPIO_2 4
#define GPIO_1 2
#define GPIO_0 0

#include <asm/gpio.h>

// GPIO mode definition
#define GPIO_MODE_INPUT  (0)
#define GPIO_MODE_OUTPUT (1)
#define GPIO_MODE_ALTER_INPUT (2)
#define GPIO_MODE_ALTER_OUTPUT (3)

#ifndef __ASSEMBLY__
#endif /* !__ASSEMBLY__ */

#endif /* __TC3162_GPIO_H__ */

