/*  
 * Definitions used to for SDRAM Controller Operation register.
 *
 * Written by Robert Wu, Billion Co.
 * Support for TrendChip TC3162
 */

#ifndef __TC3162_SDRAM_H__ 
#define __TC3162_SDRAM_H__ 

#include <asm/addrspace.h>

#define TC3162_SDRAM_BASE	(KSEG1 + 0x1FB20000)
#define TC3162_SCR_REG		(TC3162_SDRAM_BASE + 0x0 + 0x3)
#define TC3162_SAMT_REG		(TC3162_SDRAM_BASE + 0x1 + 0x3)
#define TC3162_STC_REG		(TC3162_SDRAM_BASE + 0x2 + 0x3)
#define TC3162_SRT_REG		(TC3162_SDRAM_BASE + 0x3 + 0x3)
#define TC3162_SOM_REG		(TC3162_SDRAM_BASE + 0x4 + 0x3)
#define TC3162_SMR_REG		(TC3162_SDRAM_BASE + 0x5 + 0x3)


#ifndef __ASSEMBLY__
#endif /* !__ASSEMBLY__ */

#endif /* __TC3162_SDRAM_H__ */


