#ifndef _IPT_WEBSTR_H
#define _IPT_WEBSTR_H

#define BM_MAX_NLEN 256
#define BM_MAX_HLEN 1024

#define BLK_JAVA		0x01
#define BLK_ACTIVE		0x02
#define BLK_COOKIE		0x04
#define BLK_PROXY		0x08

// FOR TMSS
#define CHECK_IF_URL_IN_DASH_BOARD		0x01
#define CHECK_IF_CLIENT_NEED_AVE_REDIRECT		0x02

// either is dashboard IP, url license disbled, url filtering disabled, not in schedule, or  in pass cache
#define CHECK_IF_URL_NO_NEED_TO_BE_RATED		0x04

#define CHECK_IF_URL_IN_BLOCKED_CACHE		0x08

typedef char *(*proc_ipt_search) (char *, char *, int, int);

struct ipt_webstr_info {
    char string[BM_MAX_NLEN];
    u_int16_t invert;
    u_int16_t len;
    u_int8_t type;
};

enum ipt_webstr_type
{
    IPT_WEBSTR_HOST=0,
    IPT_WEBSTR_URL,
    IPT_WEBSTR_CONTENT,
   IPT_WEBSTR_TMSS
 };


#define TMSS_BASE_CTL		128	/* base for tmss socket options */

#define TMSS_SO_SET_AVE_CONFIG		  (TMSS_BASE_CTL)
#define TMSS_SO_URL_RATING_COMPLETE       (TMSS_BASE_CTL + 1)
#define TMSS_SO_ADD_URL_FILTER_CACHE_NODE (TMSS_BASE_CTL + 2)
#define TMSS_SO_SET_URL_FILTER_CONFIG	  (TMSS_BASE_CTL + 3)
#define TMSS_SO_INIT_CLIENT_INFO	  (TMSS_BASE_CTL + 4)
#define TMSS_SO_TM_EXCEPTION	  	  (TMSS_BASE_CTL + 5)
#define TMSS_SO_SET_MAX			  TMSS_SO_TM_EXCEPTION

#define TMSS_SO_GET_INFO		(TMSS_BASE_CTL)
#define TMSS_SO_GET_ENTRIES		(TMSS_BASE_CTL + 1)
#define TMSS_SO_GET_MAX			TMSS_SO_GET_ENTRIES


#define HTTP_MSG_ACTION_NOT_DETERMINED 0
#define HTTP_MSG_ACTION_PASS 1
#define HTTP_MSG_ACTION_BLOCKED 2


#endif /* _IPT_WEBSTR_H */
