/*
** $Id: basic.h 1.18 2004/09/23 19:11:00 cmchang Exp $
*/

/******************************************************************************
Copyright (c) 2002-2003 Integrated Programmable Communications, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with
Integrated Programmable Communications, Inc.
******************************************************************************/

#ifndef _BASIC_H
#define _BASIC_H

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/
#ifndef INT8
#define INT8                    char
#define INT16                   short
#define INT32                   long
#define INT64                   long long
#endif

#ifndef UINT8
#define UINT8                   unsigned char
#define UINT16                  unsigned short
#define UINT32                  unsigned long
#define UINT64                  unsigned long long
#endif

#ifndef INT
#define INT                     int
#define UINT                    unsigned int
#endif

#ifndef CHAR
#define CHAR                    char
#endif

#ifndef SHORT
#define SHORT                   short
#endif

#ifndef LONG
#define LONG                    long
#endif

#ifndef UCHAR
#define UCHAR                   unsigned char
#define USHORT                  unsigned short
#define ULONG                   unsigned long
#endif

#ifndef LONGLONG
#define LONGLONG                long long
#define ULONGLONG               unsigned long long
#endif

#ifndef BOOLEAN
#define BOOLEAN                 int
#endif

#ifndef bool
#define bool                    int
#endif

#ifndef FALSE
#define FALSE           0
#define TRUE            1
#endif

#ifndef false
#define false           0
#define true            1
#endif

#ifndef NULL
#if defined(__cplusplus)
        #define NULL 0
#else
        #define NULL ((void *)0)
#endif
#endif

/* Generally referenced structure */
typedef struct i2220mgmt_       i2220mgmt_t;
typedef struct sta_info_        sta_info_t;
typedef struct ap_info_         ap_info_t;

/* IPN_NEW_KAL shoulde be defined in file wlan_kal.h */
#ifdef IPN_NEW_KAL
typedef void            kal_pci_dev_t;
typedef void            kal_net_device_t;
typedef void            kal_skb_t;
typedef UINT32          kal_dma_addr_t;
#endif

/* __ARCH_REALTEK_RTL8651__ should be defined by compiler flags */
#ifdef __ARCH_REALTEK_RTL8651__
#define KAL_IRAM        __IRAM  /* Internal RAM */
#else
#define KAL_IRAM
#endif

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/

/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*           I N L I N E   F U N C T I O N   D E F I N I T I O N S
*************************************************************************
*/

#endif /* _BASIC_H */

