# ---------------------------------------------------------------------------
# Copyright (c) 2002-2003 Inprocomm, Inc.
#
# All rights reserved. Copying, compilation, modification, distribution
# or any other use whatsoever of this material is strictly prohibited
# except in accordance with a Software License Agreement with Inprocomm, Inc.
# ---------------------------------------------------------------------------

ARCH=$(shell echo $$ARCH)
ifeq ($(strip $(ARCH)), )
ARCH=i386
endif

KCFLAGS         = -D__KERNEL__ -Wstrict-prototypes -Wno-trigraphs -O2 -fomit-frame-pointer \
                        -fno-strict-aliasing -fno-common
KERNEL_MODFLAGS = -DMODULE

# Intel x86 CPU, Little Endian
ifeq ($(ARCH), i386)
D_ARCH=__ARCH_INTEL_I386__
CPU_ENDIAN=0
LINUX_SRC=/usr/src/linux-i386
CROSS_COMPILE=
KERNEL_CFLAGS=$(KCFLAGS) -Wall -Wno-unused -pipe -mpreferred-stack-boundary=2 -march=i686 \
                -malign-functions=4
endif

# ---------------------------------------------------
MAKE     = make

AS       = $(CROSS_COMPILE)as
LD       = $(CROSS_COMPILE)ld
CC       = $(CROSS_COMPILE)gcc
AR       = $(CROSS_COMPILE)ar
NM       = $(CROSS_COMPILE)nm
STRIP    = $(CROSS_COMPILE)strip
OBJCOPY  = $(CROSS_COMPILE)objcopy
OBJDUMP  = $(CROSS_COMPILE)objdump
RANLIB   = $(CROSS_COMPILE)ranlib
CPP      = $(CC) -E

# ---------------------------------------------------
# Build options
# ---------------------------------------------------
# Enable debug mode
WLAN_DEBUG=n

# Support proc file system
WLAN_PROC=y

# Support WDS networks
WLAN_WDS=y

# Support RF testing for EMI certification
WLAN_Rftest=y

# Support Memory Pool instead of system malloc
WLAN_MEMPool=y

# Support WPA and ACL functions for Linux hostapd
WLAN_support_IPNRSN=y

# Support the extern Linux-based Hostapd for 802-11i, inlude the RSN and WPA
WLAN_support_80211i=n

# Support the TKIP security
WLAN_support_TKIP=y

# Support software calculation of partial TKIP MIC
WLAN_support_TKIP_SW_MIC=n

# Support IPN5320 for dual band operation
WLAN_support_IPN5320=y

# ---------------------------------------------------
ifeq ($(WLAN_DEBUG), y)
WLAN_INCLUDE_DEBUG=-DWLAN_INCLUDE_DEBUG=1
endif

ifeq ($(WLAN_PROC), y)
WLAN_INCLUDE_PROC=-DWLAN_INCLUDE_PROC=1
endif

ifeq ($(WLAN_WDS), y)
WLAN_INCLUDE_WDS=-DWLAN_INCLUDE_WDS=1
endif

ifeq ($(WLAN_Rftest), y)
WLAN_SUPPORT_RFTEST=-DWLAN_SUPPORT_RFTEST=1
endif

ifeq ($(WLAN_MEMPool), y)
WLAN_USE_MEMPOOL=-DWLAN_USE_MEMPOOL=1
endif

ifeq ($(WLAN_support_80211i), y)
WLAN_SUPPORT_80211i=-DSUPPORT_WPA2=1
WLAN_support_IPNRSN=n
endif

ifeq ($(WLAN_support_IPNRSN), y)
WLAN_SUPPORT_IPNRSN=-DSUPPORT_IPNRSN=1
WLAN_SUPPORT_80211i=-DSUPPORT_WPA2=0
endif

ifeq ($(WLAN_support_TKIP), y)
WLAN_SUPPORT_TKIP=-DSUPPORT_TKIP=1
endif

ifeq ($(WLAN_support_TKIP_SW_MIC), y)
WLAN_SUPPORT_TKIP_SW_MIC=-DSUPPORT_SW_TKIP_MIC=1
endif

ifeq ($(WLAN_support_IPN5320), y)
WLAN_SUPPORT_IPN5320=-DIPN5320=1
endif

# ---------------------------------------------------
# Preprocessor Options
# ---------------------------------------------------
CFLAGS = $(KERNEL_CFLAGS) $(KERNEL_MODFLAGS) \
        -D$(D_ARCH) -D__CPU_ENDIAN__=$(CPU_ENDIAN)
CPPFLAGS = -I$(OS_DIR) -I$(LINUX_SRC)/include -I../include/ipn2220 \
        $(WLAN_INCLUDE_DEBUG) $(WLAN_INCLUDE_PROC) $(WLAN_SUPPORT_RFTEST) \
        $(WLAN_INCLUDE_WDS) $(WLAN_USE_MEMPOOL) $(WLAN_SUPPORT_IPNRSN) \
        $(WLAN_SUPPORT_TKIP) $(WLAN_SUPPORT_TKIP_SW_MIC) $(WLAN_SUPPORT_80211i) \
        $(WLAN_SUPPORT_IPN5320)
LDFLAGS += -r
