/*
** $Id: phy.c 1.36 2004/10/05 10:00:43 cmchang Exp $
*/

/*************************************************************************
* Copyright (c) 2002-2004 Inprocomm, Inc.
*
* All rights reserved. Copying, compilation, modification, distribution
* or any other use whatsoever of this material is strictly prohibited
* except in accordance with a Software License Agreement with
* Inprocomm, Inc.
**************************************************************************/
/*************************************************************************
GENERAL DESCRIPTION
********************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/
#include "precomp.h"


/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/
const NIC_BBCR_CONFIG_ENTRY phyOFDMTXBackOff[] = {
    {"CR39", 39, 0x00},
    {"CR40", 40, 0x66},
    {"CR39", 39, 0x01},
    {"CR40", 40, 0x08},
    {"CR39", 39, 0x02},
    {"CR40", 40, 0x20},
    {"CR39", 39, 0x03},
    {"CR40", 40, 0x66},
    {"CR39", 39, 0x04},
    {"CR40", 40, 0x08},
    {"CR39", 39, 0x05},
    {"CR40", 40, 0x20},
};

const NIC_BBCR_CONFIG_ENTRY phyOFDMTXBackOffforJapan[] = {
    {"CR39", 39, 0x00},
    {"CR40", 40, 0x65},
    {"CR39", 39, 0x01},
    {"CR40", 40, 0x96},
    {"CR39", 39, 0x02},
    {"CR40", 40, 0x59},
    {"CR39", 39, 0x03},
    {"CR40", 40, 0x65},
    {"CR39", 39, 0x04},
    {"CR40", 40, 0x96},
    {"CR39", 39, 0x05},
    {"CR40", 40, 0x59},
};


const NIC_BBCR_CONFIG_ENTRY phyRFTxPowerSpectrum[] = {
    {"CR41", 41, 0x00},
    {"CR42", 42, 0x21},
    {"CR41", 41, 0x01},
    {"CR42", 42, 0xf7},
    {"CR41", 41, 0x02},
    {"CR42", 42, 0xee},
    {"CR41", 41, 0x03},
    {"CR42", 42, 0xeb},
    {"CR41", 41, 0x04},
    {"CR42", 42, 0xe6},
    {"CR41", 41, 0x05},
    {"CR42", 42, 0xf0},
    {"CR41", 41, 0x06},
    {"CR42", 42, 0x0f},
    {"CR41", 41, 0x07},
    {"CR42", 42, 0x3a},
    {"CR41", 41, 0x08},
    {"CR42", 42, 0x63},
    {"CR41", 41, 0x09},
    {"CR42", 42, 0x7c},
    {"CR43", 43, 0x00},
    {"CR44", 44, 0xfe},
    {"CR43", 43, 0x01},
    {"CR44", 44, 0xfe},
    {"CR43", 43, 0x02},
    {"CR44", 44, 0x05},
    {"CR43", 43, 0x03},
    {"CR44", 44, 0x1b},
    {"CR43", 43, 0x04},
    {"CR44", 44, 0x3e},
    {"CR43", 43, 0x05},
    {"CR44", 44, 0x59}
};

const NIC_BBCR_CONFIG_ENTRY phyRFTxPowerSpectrumForGCTCCK[] = {
    {"CR43", 43, 0x00},
    {"CR44", 44, 0xff},
    {"CR43", 43, 0x01},
    {"CR44", 44, 0xff},
    {"CR43", 43, 0x02},
    {"CR44", 44, 0x03},
    {"CR43", 43, 0x03},
    {"CR44", 44, 0x0f},
    {"CR43", 43, 0x04},
    {"CR44", 44, 0x23},
    {"CR43", 43, 0x05},
    {"CR44", 44, 0x32}
};


const NIC_BBCR_CONFIG_ENTRY phyRFTxPowerSpectrumForJapanCh14[] = {
    {"CR43", 43, 0x00},
    {"CR44", 44, 0x01},
    {"CR43", 43, 0x01},
    {"CR44", 44, 0x00},
    {"CR43", 43, 0x02},
    {"CR44", 44, 0xf7},
    {"CR43", 43, 0x03},
    {"CR44", 44, 0xf7},
    {"CR43", 43, 0x04},
    {"CR44", 44, 0x2b},
    {"CR43", 43, 0x05},
    {"CR44", 44, 0x76}
};


/************************************************************************
*                       P R I V A T E   D A T A
*************************************************************************
*/
DEBUGFILE("phy.c");


/************************************************************************
*                             M A C R O S
*************************************************************************
*/


/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/

/*_________________________________________________________________________
**  phyWriteBBCrList
**
**  descriptions: This routine will write the given CR list to the
**                baseband.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      bbCrList_p - Pointer to the baseband CR list for the setting
**      bbCrListSize - The size of the baseband CR list for the setting
**  return:       (none)
**  note:
**__________________________________________________________________________*/
VOID
phyWriteBBCrList(IN PMP_ADAPTER adapter_p,
                 IN PNIC_BBCR_CONFIG_ENTRY bbCrList_p,
                 IN UINT bbCrListSize)
{
    UINT i;
    UINT_8 bbOffset;
    UINT_8 initValue;
#if DBG
    UINT_8 temp8;
#endif

    DEBUGFUNC("phyWriteBBCrList");

    DBGLOG(INIT, TRACE, ("\n"));

    for (i = 0; i < bbCrListSize; i++) {
        initValue = bbCrList_p[i].value;
        bbOffset  = bbCrList_p[i].offset;

        BCIWrite8(adapter_p, bbOffset, initValue, FALSE, 0);

#if DBG
        BCIRead8(adapter_p, bbOffset, &temp8, FALSE, 0);
        DBGLOG(INIT, INFO, ("PHY BBCR Init: offset=%04d, value=0x%02x\n",
            bbOffset, temp8));
#endif
    }
}   /* phyWriteBBCrList */

/*_________________________________________________________________________
**  phyWriteRFInitTable
**
**  descriptions: This routine will write the given RF initial table to
**                the RF chipset through the PSPR register.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      rfInitTable_p - Pointer to the RF initial table
**      rfInitTableSize - The size of the RF initial table
**      waitDelay - The delay to wait after writing a value to the PSPR, in
**                  units of us
**  return:       (none)
**  note:
**__________________________________________________________________________*/
VOID
phyWriteRFInitTable(IN PMP_ADAPTER adapter_p,
                    IN PUINT_32 rfInitTable_p,
                    IN UINT rfInitTableSize,
                    IN UINT waitDelay)
{
    UINT i, j;
    UINT waitCount;
    BOOLEAN status;

    DEBUGFUNC("phyWriteRFInitTable");

    waitCount = (waitDelay + 19) / 20;

    for (i = 0; i < rfInitTableSize; i++) {
        DBGLOG(INIT, INFO, ("RF init: PSPR write 0x%08x\n", rfInitTable_p[i]));

        NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, rfInitTable_p[i],
            PSPR_SYNTH_PROG_START, 2, 5, status);
        ASSERT(status);

        for (j = 0; j < waitCount; j++) {
            NdisStallExecution(20);
        }
    }
}   /* phyWriteRFInitTable */

/*_________________________________________________________________________
**  phyBBWriteAGCTable
**
**  descriptions: This routine is called to write 8-bit data to the AGC
**                table in the Baseband through the BCI interface.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      agcTableAddr - The address in the AGC table for the write operation
**      agcTableData - The data that will be written to the AGC table
**  return:
**      TRUE - write success
**      FALSE - write fail
**  note:
**__________________________________________________________________________*/
BOOLEAN
phyBBWriteAGCTable(IN PMP_ADAPTER adapter_p,
                   IN UINT_8 agcTableAddr,
                   IN UINT_8 agcTableData)
{
    BOOLEAN result;

    DEBUGFUNC("phyBBWriteAGCTable");

    do {
        result = BCIWrite8(adapter_p, BBCR_CR45, agcTableAddr, TRUE, 0xff);

        if (!result) {
            ERRORLOG(("Failed to write AGC table addr 0x%02x to CR45\n",
                agcTableAddr));
            break;
        }

        result = BCIWrite8(adapter_p, BBCR_CR46, agcTableData, TRUE, 0xff);

        if (!result) {
            ERRORLOG(("Failed to write AGC table data 0x%02x to CR46\n",
                agcTableData));
            break;
        }

        DBGLOG(HW, INFO,
            ("AGC table write succeeded - CR45=0x%02x, CR46=0x%02x\n",
            agcTableAddr, agcTableData));
    } while (FALSE);

    return result;
}   /* phyBBWriteAGCTable */

/*_________________________________________________________________________
**  phyBBReadAGCTable
**
**  descriptions: This routine is called to read 8-bit data from the AGC
**                table in the Baseband through the BCI interface.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      agcTableAddr - The address in the AGC table for the read operation
**  results:
**      agcTableData_p - Pointer to the read data
**  return:
**      TRUE - read success
**      FALSE - read fail
**  note:
**__________________________________________________________________________*/
BOOLEAN
phyBBReadAGCTable(IN PMP_ADAPTER adapter_p,
                  IN UINT_8 agcTableAddr,
                  OUT PUINT_8 agcTableData_p)
{
    BOOLEAN result;
    UINT_8 readData;

    DEBUGFUNC("phyBBReadAGCTable");

    do {
        result = BCIWrite8(adapter_p, BBCR_CR45, agcTableAddr, TRUE, 0xff);

        if (!result) {
            ERRORLOG(("Failed to write AGC table addr 0x%02x to CR45\n",
                agcTableAddr));
            break;
        }

        result = BCIRead8(adapter_p, BBCR_CR46, &readData, TRUE, 0xff);

        if (!result) {
            ERRORLOG(("Failed to read AGC table data from CR46\n"));
            break;
        }

        DBGLOG(HW, INFO,
            ("AGC table read succeeded - CR45=0x%02x, CR46=0x%02x\n",
            agcTableAddr, readData));
    } while (FALSE);

    if (result) {
        *agcTableData_p = readData;
    } else {
        *agcTableData_p = 0xFF;
    }

    return result;
}   /* phyBBReadAGCTable */

#if SUPPORT_802_11A
/*_________________________________________________________________________
**  phyChangePhyType
**
**  descriptions: This routine is called to change the current PHY type.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      newPhyType - The new PHY type
**  return:       TRUE, if we have successfully changed the PHY type
**                FALSE, if we failed to change the PHY type
**  note:
**__________________________________________________________________________*/
BOOLEAN
phyChangePhyType(IN PMP_ADAPTER adapter_p,
                 IN UINT_32 newPhyType)
{
    BOOLEAN status = TRUE;
    UINT_8 tmp8;

    DEBUGFUNC("phyChangePhyType");

    if (adapter_p->rfSpecificConfig_p == NULL) {
        ERRORLOG(("Unsupported RF Type\n"));
        return FALSE;
    }

    do {
        if (newPhyType == PHY_TYPE_OFDM &&
            (adapter_p->rfSpecificConfig_p->phyRFChannelTable5_p == NULL ||
            adapter_p->rfSpecificConfig_p->phyRFChannelTableLen5 == 0)) {
            status = FALSE;
            break;
        }

        BCIRead8(adapter_p, BBCR_CR3, &tmp8, TRUE, 0xff);
        if (newPhyType == PHY_TYPE_OFDM) {
            tmp8 |= CR3_BAND_5G_ENABLE | CR3_RX_CCK_DISABLE;
        } else {
            tmp8 &= ~(CR3_BAND_5G_ENABLE | CR3_RX_CCK_DISABLE);
        }
        BCIWrite8(adapter_p, BBCR_CR3, tmp8, TRUE, 0xff);

        if (newPhyType == PHY_TYPE_OFDM) {
            if (adapter_p->rfSpecificConfig_p->phyBBInitTable5_p) {
                phyWriteBBCrList(adapter_p,
                    adapter_p->rfSpecificConfig_p->phyBBInitTable5_p,
                    adapter_p->rfSpecificConfig_p->phyBBInitTableLen5);
            }

            if (adapter_p->rfSpecificConfig_p->phyRFInitTable5_p) {
                phyWriteRFInitTable(adapter_p,
                    adapter_p->rfSpecificConfig_p->phyRFInitTable5_p,
                    adapter_p->rfSpecificConfig_p->phyRFInitTableLen5,
                    adapter_p->rfSpecificConfig_p->phyRFInitWaitDelay);
            }
        } else {
            if (adapter_p->rfSpecificConfig_p->phyBBInitTable24_p) {
                phyWriteBBCrList(adapter_p,
                    adapter_p->rfSpecificConfig_p->phyBBInitTable24_p,
                    adapter_p->rfSpecificConfig_p->phyBBInitTableLen24);
            }

            if (adapter_p->rfSpecificConfig_p->phyRFInitTable24_p) {
                phyWriteRFInitTable(adapter_p,
                    adapter_p->rfSpecificConfig_p->phyRFInitTable24_p,
                    adapter_p->rfSpecificConfig_p->phyRFInitTableLen24,
                    adapter_p->rfSpecificConfig_p->phyRFInitWaitDelay);
            }
        }
    } while (FALSE);

    return status;
}   /* phyChangePhyType */
#endif

/*_________________________________________________________________________
**  phyRFInitAndWait
**
**  descriptions: This routine initialize RF and wait reset complete.
**                Caller must be at IRQL >= DISPATCH_LEVEL
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
VOID
phyRFInitAndWait(IN PMP_ADAPTER adapter_p)
{
    UINT_32 paDisableMask = 0;
    UINT_32 temp32;

    DEBUGFUNC("phyRFInitAndWait");

    INITLOG(("\n"));

    NIC_MCR_READ(adapter_p, MCR_PCICR, &temp32);
    if (!(temp32 & PCICR_PA2_POLARITY)) {
        paDisableMask |= PPMCR_GPIO_PA2_EN;
    }

    if (!(temp32 & PCICR_PA5_POLARITY)) {
        paDisableMask |= PPMCR_GPIO_PA5_EN;
    }

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &temp32);
    temp32 = (temp32 & ~(PPMCR_GPIO_PA2_EN | PPMCR_GPIO_PA5_EN)) |
        paDisableMask;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, temp32);

    if (adapter_p->rfSpecificConfig_p == NULL) {
        ERRORLOG(("Unsupported RF Type\n"));
        return;
    }
    ASSERT(adapter_p->rfSpecificConfig_p->phyRFInitHandler);

    adapter_p->rfSpecificConfig_p->phyRFInitHandler(adapter_p);

#if WORKAROUND_TXDAC_POWER_CONSUMPTION
    if (adapter_p->rfSpecificConfig_p->txDACon) {
        BCIWrite8(adapter_p, BBCR_CR88, 0x80, TRUE, 0xff);
    } else {
        BCIWrite8(adapter_p, BBCR_CR88, 0x00, TRUE, 0xff);
    }
#endif
}   /* phyRFInitAndWait */

/*_________________________________________________________________________
**  phyRFEnterActive
**
**  descriptions: This routine enter RF active state
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
VOID
phyRFEnterActive(IN PMP_ADAPTER adapter_p)
{
    DEBUGFUNC("phyRFEnterActive");

    DBGLOG(HW, TRACE, ("\n"));

    if (adapter_p->rfSpecificConfig_p == NULL) {
        ERRORLOG(("Unsupported RF Type\n"));
        return;
    }
    ASSERT(adapter_p->rfSpecificConfig_p->phyRFEnterActiveHandler);

    adapter_p->rfSpecificConfig_p->phyRFEnterActiveHandler(adapter_p);

    NdisStallExecution(250);
}   /* phyRFEnterActive */

/*_________________________________________________________________________
**  phyRFEnterSleep
**
**  descriptions: This routine enter RF sleep state
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
VOID
phyRFEnterSleep(IN PMP_ADAPTER adapter_p)
{
    DEBUGFUNC("phyRFEnterSleep");

    DBGLOG(HW, TRACE, ("\n"));

    if (adapter_p->rfSpecificConfig_p == NULL) {
        ERRORLOG(("Unsupported RF Type\n"));
        return;
    }
    ASSERT(adapter_p->rfSpecificConfig_p->phyRFEnterSleepHandler);

    adapter_p->rfSpecificConfig_p->phyRFEnterSleepHandler(adapter_p);

    NdisStallExecution(10);
} /* phyRFEnterSleep */

/*_________________________________________________________________________
**  phyRFCalibration
**
**  descriptions: This routine is called to perform RF calibration, if
**                enabled.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      configEntry_p - Pointer to the per-channel configuration entry
**  return:
**  note:
**__________________________________________________________________________*/
VOID
phyRFCalibration(IN PMP_ADAPTER adapter_p,
                 IN PNIC_PER_CHANNEL_CONFIG configEntry_p)
{
    UINT i;
    UINT_8 calValue;

    for (i = 0; i < RF_CAL_TX_CR_NO; i++) {
        if (configEntry_p->txCalEnabled) {
            calValue = configEntry_p->txCalSet[i];
        } else {
            calValue = 0;
        }

        BCIWrite8(adapter_p, RF_CAL_ADDR_PORT, (UINT_8) (RF_CAL_TX_TABLE_START_ADDR + i),
            TRUE, 0xff);
        BCIWrite8(adapter_p, RF_CAL_DATA_PORT, calValue, TRUE, 0xff);
    }

    for (i = 0; i < RF_CAL_RX_CR_NO; i++) {
        if (configEntry_p->rxCalEnabled) {
            calValue = configEntry_p->rxCalSet[i];
        } else {
            calValue = 0;
        }

        BCIWrite8(adapter_p, RF_CAL_ADDR_PORT, (UINT_8) (RF_CAL_RX_TABLE_START_ADDR + i),
            TRUE, 0xff);
        BCIWrite8(adapter_p, RF_CAL_DATA_PORT, calValue, TRUE, 0xff);
    }
}   /* phyRFCalibration */

/*_________________________________________________________________________
**  phyBBInit
**
**  descriptions: This routine initialize baseband
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
VOID
phyBBInit(IN PMP_ADAPTER adapter_p)
{
    DEBUGFUNC("phyBBInit");

    INITLOG(("\n"));

    if (adapter_p->rfSpecificConfig_p == NULL) {
        ERRORLOG(("Unsupported RF Type\n"));
        return;
    }

    if (adapter_p->rfSpecificConfig_p->phyBBInitCommonTable_p) {
        INITLOG(("Initialize BB with common BB init table\n"));

        phyWriteBBCrList(adapter_p,
            adapter_p->rfSpecificConfig_p->phyBBInitCommonTable_p,
            adapter_p->rfSpecificConfig_p->phyBBInitCommonTableLen);
    }

#if SUPPORT_802_11A
    if (adapter_p->currentPhyType == PHY_TYPE_OFDM) {
        if (adapter_p->rfSpecificConfig_p->phyBBInitTable5_p) {
            INITLOG(("Initialize BB with 5-GHz BB init table\n"));

            phyWriteBBCrList(adapter_p,
                adapter_p->rfSpecificConfig_p->phyBBInitTable5_p,
                adapter_p->rfSpecificConfig_p->phyBBInitTableLen5);
        }
    } else
#endif
    {
        if (adapter_p->rfSpecificConfig_p->phyBBInitTable24_p) {
            INITLOG(("Initialize BB with 2.4-GHz BB init table\n"));

            phyWriteBBCrList(adapter_p,
                adapter_p->rfSpecificConfig_p->phyBBInitTable24_p,
                adapter_p->rfSpecificConfig_p->phyBBInitTableLen24);
        }
    }

    INITLOG(("Set default Tx spectrum mask\n"));

    phySetTxSpectrumMask(adapter_p);

    INITLOG(("Set OFDM Tx power backoff\n"));

    phySetTXBackoff(adapter_p, adapter_p->mib.dot11CurrentRegDomain);
} /* phyBBInit */

/*_________________________________________________________________________
**  phySetTxSpectrumMask
**
**  descriptions: This routine is called to set the default transmit
**                spectrum mask.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:         (none)
**  note:
**__________________________________________________________________________*/
VOID
phySetTxSpectrumMask(IN PMP_ADAPTER adapter_p)
{
    phyWriteBBCrList(adapter_p, (PNIC_BBCR_CONFIG_ENTRY) phyRFTxPowerSpectrum,
        sizeof(phyRFTxPowerSpectrum) / sizeof(NIC_BBCR_CONFIG_ENTRY));
}   /* phySetTxSpectrumMask */

/*_________________________________________________________________________
**  phySetTxSpectrumMaskForJapanCh14
**
**  descriptions: This routine is called to set the transmit spectrum mask
**                for Channel 14 in Japan.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      channelNum - channel number
**      channelBand - The channel band to which the given channel number
**                    belongs
**  return:         (none)
**  note:
**__________________________________________________________________________*/
VOID
phySetTxSpectrumMaskForJapanCh14(IN PMP_ADAPTER adapter_p)
{
    phyWriteBBCrList(adapter_p,
        (PNIC_BBCR_CONFIG_ENTRY) phyRFTxPowerSpectrumForJapanCh14,
        sizeof(phyRFTxPowerSpectrumForJapanCh14) /
        sizeof(NIC_BBCR_CONFIG_ENTRY));
}   /* phySetTxSpectrumMaskForJapanCh14 */

/*_________________________________________________________________________
**  phyRFCheckForValidChannel
**
**  descriptions: This routine is called to check whether a given channel
**                number is valid for the current RF control mode.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      channelNum - The channel number to be checked
**      channelBand - The channel band to which the given channel number
**                    belongs
**  results:
**      channelProgEntry_p - Pointer to the RF channel programming entry
**                           for the given channel
**  return:
**      TRUE - The given channel is valid.
**      FALSE - The given channel is not valid.
**  note:
**__________________________________________________________________________*/
BOOLEAN
phyRFCheckForValidChannel(IN PMP_ADAPTER adapter_p,
                          IN UINT_8 channelNum,
#if SUPPORT_802_11A
                          IN UINT_8 channelBand,
#endif
                          OUT PVOID *channelProgEntry_p)
{
    INT i, j, k;
    PNIC_RF_CHANNEL_PROG_ENTRY table_p;

    *channelProgEntry_p = NULL;

if (adapter_p->rfSpecificConfig_p == NULL) {
    ERRORLOG(("Unsupported RF Type\n"));
    return FALSE;
}

#if SUPPORT_802_11A
    if (channelBand == CHANNEL_BAND_5) {
        table_p = adapter_p->rfSpecificConfig_p->phyRFChannelTable5_p;
        j = (INT) adapter_p->rfSpecificConfig_p->phyRFChannelTableLen5;
    } else
#endif
    {
        table_p = adapter_p->rfSpecificConfig_p->phyRFChannelTable24_p;
        j = (INT) adapter_p->rfSpecificConfig_p->phyRFChannelTableLen24;
    }

    if (table_p == NULL || j == 0) {
        return FALSE;
    }

    i = 0;
    j -= 1;

    while (i <= j) {
        k = (i + j) / 2;

        if (channelNum == table_p[k].channelNum) {
            *channelProgEntry_p = (PVOID) &table_p[k];
            return TRUE;
        }

        if (channelNum < table_p[k].channelNum) {
            j = k - 1;
        } else {
            i = k + 1;
        }
    }

    return FALSE;
}   /* phyRFCheckForValidChannel */

/*_________________________________________________________________________
**  phyRFSwitchChannel
**
**  descriptions: This routine is called to switch channel.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      channelNum - The new channel number
**      channelBand - The channel band to which the given channel number
**                    belongs
**      txPowerLimit - The tx power limit, in dBm. The value of 0xFF
**                     indicates the maximum tx power of the NIC is used.
**  return:       TRUE, if channel setting successful
**                FALSE, if channel setting false
**  note:
**__________________________________________________________________________*/
BOOLEAN
phyRFSwitchChannel(IN PMP_ADAPTER adapter_p,
                   IN UINT_8 channelNum,
#if SUPPORT_802_11A
                   IN UINT_8 channelBand,
#endif
                   IN UINT_8 txPowerLimit)
{
#if SUPPORT_802_11A
    UINT    i;
#endif
    PNIC_RF_CHANNEL_PROG_ENTRY chnlProgEntry_p;
    BOOLEAN status;
    PNIC_PER_CHANNEL_CONFIG configEntry_p;

    DEBUGFUNC("phyRFSwitchChannel");

#if SUPPORT_802_11A
    DBGLOG(HW, TRACE, ("Switch to Channel %d (band=%d)\n", channelNum,
        channelBand));

    status = phyRFCheckForValidChannel(adapter_p, channelNum, channelBand,
        (PVOID *) &chnlProgEntry_p);
#else
    DBGLOG(HW, TRACE, ("Switch to Channel %d\n", channelNum));

    status = phyRFCheckForValidChannel(adapter_p, channelNum,
        (PVOID *) &chnlProgEntry_p);
#endif

    if (!status) {
        ERRORLOG(("Invalid channel number: %d\n", channelNum));
        return FALSE;
    }

#if SUPPORT_ED_ADJUST && SUPPORT_ED_FORCETO_FLOAT
    edSetNoiseFloorFloat(adapter_p);
#endif

#if SUPPORT_802_11A
    DBGLOG(HW, LOUD,
        ("Channel programming entry: CH=%d (band=%d), num=%d, 0x%08x, 0x%08x, 0x%08x\n",
        chnlProgEntry_p->channelNum, channelBand,
        chnlProgEntry_p->numSynthProgWords,
        chnlProgEntry_p->synthProgWords[0],
        chnlProgEntry_p->synthProgWords[1],
        chnlProgEntry_p->synthProgWords[2]));
#else
    DBGLOG(HW, LOUD,
        ("Channel programming entry: CH=%d, num=%d, 0x%08x, 0x%08x, 0x%08x\n",
        chnlProgEntry_p->channelNum, chnlProgEntry_p->numSynthProgWords,
        chnlProgEntry_p->synthProgWords[0], chnlProgEntry_p->synthProgWords[1],
        chnlProgEntry_p->synthProgWords[2]));
#endif

    if (adapter_p->rfSpecificConfig_p == NULL) {
        ERRORLOG(("Unsupported RF Type\n"));
        return FALSE;
    }

    ASSERT(adapter_p->rfSpecificConfig_p->phyRFSwitchChannelHandler);

    adapter_p->rfSpecificConfig_p->phyRFSwitchChannelHandler(adapter_p,
        chnlProgEntry_p);

    NdisStallExecution(100);

    if (adapter_p->mib.dot11CurrentRegDomain == MIB_REG_DOMAIN_JAPAN) {
#if SUPPORT_802_11A
        if (channelBand == CHANNEL_BAND_24 && channelNum == 14)
#else
        if (channelNum == 14)
#endif
        {
            phySetTxSpectrumMaskForJapanCh14(adapter_p);
        } else {
            phySetTxSpectrumMask(adapter_p);
        }
    }

#if SUPPORT_802_11A
    if (channelBand == CHANNEL_BAND_5) {
        if (nicGetPerChannelConfigIndex5(channelNum, &i)) {
            ASSERT(i < MAX_NUM_5G_RF_CHANNELS);

            configEntry_p = &adapter_p->nicPerChannelConfig5[i];
        } else {
            configEntry_p = NULL;
        }
    } else
#endif
    {
        ASSERT(channelNum);

        configEntry_p = &adapter_p->nicPerChannelConfig24[channelNum - 1];
    }

    if (configEntry_p) {
#if SUPPORT_802_11A
        nicSetTxPowerGain(adapter_p, configEntry_p, channelBand, txPowerLimit);
#else
        nicSetTxPowerGain(adapter_p, configEntry_p, txPowerLimit);
#endif

        phyRFCalibration(adapter_p, configEntry_p);
    }

    return TRUE;
}   /* phyRFSwitchChannel */

/*_________________________________________________________________________
**  phySetRxAntenna
**
**  descriptions: This routine is called to set Rx antenna selection mode.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      newAntennaMode - The new Rx antenna mode to be set
**  return:
**  note:
**__________________________________________________________________________*/
BOOLEAN
phySetRxAntenna(IN PMP_ADAPTER adapter_p,
                IN UINT_32 newAntennaMode)
{
    UINT_8 tmp8;
    BOOLEAN succeeded;

    DEBUGFUNC("phySetRxAntenna");

    do {
        succeeded = BCIRead8(adapter_p, BBCR_CR3, &tmp8, TRUE, 0xFF);
        if (!succeeded) {
            WARNLOG(("Cannot read CR3 for setting Rx antenna\n"));
            break;
        }

        tmp8 &= ~CR3_RX_ANT_SELECTION_MODE;

        switch (newAntennaMode) {
            case NIC_ANT_MODE_FIXED_0:
                 DBGLOG(HW, TRACE, ("Fixed Rx antenna 0\n"));
                 tmp8 |= CR3_RX_ANT_FIXED_0;
                 break;

            case NIC_ANT_MODE_FIXED_1:
                 DBGLOG(HW, TRACE, ("Fixed Rx antenna 1\n"));
                 tmp8 |= CR3_RX_ANT_FIXED_1;
                 break;

            default:
                 DBGLOG(HW, TRACE, ("Rx antenna diversity\n"));
                 tmp8 |= CR3_RX_ANT_DIVERSITY_AGC;
        }

        succeeded = BCIWrite8(adapter_p, BBCR_CR3, tmp8, TRUE, 0xFF);
        if (!succeeded) {
            WARNLOG(("Failed to write CR3 for setting Rx antenna\n"));
        }
    } while (FALSE);

    return succeeded;
}   /* phySetRxAntenna */

/*_________________________________________________________________________
**  phySetTXBackoff
**
**  descriptions: This routine is called to set the OFDM TX Power Backoff
**                according to the regulation domain.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      UINT_32   - Regulation Domain
**  return:         (none)
**  note:
**__________________________________________________________________________*/
VOID
phySetTXBackoff(IN PMP_ADAPTER adapter_p,
                IN UINT_32 regulationDomain)
{

    DEBUGFUNC("phySetTXBackoff");

    switch (regulationDomain) {
        case MIB_REG_DOMAIN_JAPAN:
             DBGLOG(HW, INFO, ("Use Japan Back off setting\n"));
             phyWriteBBCrList(adapter_p,
                 (PNIC_BBCR_CONFIG_ENTRY) phyOFDMTXBackOffforJapan,
                 sizeof(phyOFDMTXBackOffforJapan) /
                 sizeof(NIC_BBCR_CONFIG_ENTRY));
             break;
        case MIB_REG_DOMAIN_FCC:
        case MIB_REG_DOMAIN_IC:
        case MIB_REG_DOMAIN_ETSI:
        case MIB_REG_DOMAIN_SPAIN:
        case MIB_REG_DOMAIN_FRANCE:
        default:
             DBGLOG(HW, INFO, ("Use Universal Back off setting\n"));
             phyWriteBBCrList(adapter_p,
                 (PNIC_BBCR_CONFIG_ENTRY) phyOFDMTXBackOff,
                 sizeof(phyOFDMTXBackOff) / sizeof(NIC_BBCR_CONFIG_ENTRY));
    }

}   /* phySetTXBackoff */

