/*
** $Id: rf_ubec.c 1.1 2004/10/04 17:56:33 cmchang Exp $
*/

/*************************************************************************
* Copyright (c) 2004 Inprocomm, Inc.
*
* All rights reserved. Copying, compilation, modification, distribution
* or any other use whatsoever of this material is strictly prohibited
* except in accordance with a Software License Agreement with
* Inprocomm, Inc.
**************************************************************************/
/*************************************************************************
GENERAL DESCRIPTION
********************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/
#include "precomp.h"


/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
#define PAU_TNTDR_UBEC_LONG_SLOT                0x0210008a
#define PAU_TNTDR_UBEC_SHORT_SLOT               0x0134008a

#define PAU_STDR_UBEC_LONG_SLOT                 0x019001a4
#define PAU_STDR_UBEC_SHORT_SLOT                0x00b400c8

#define RF_INIT_WAIT_DELAY_UBEC                 60

#define RSSI_AT_NOISE_FLOOR_BASELINE_UBEC_24    -69

#define TX_POWER_GAIN_UBEC_CCK                  0x30
#define TX_POWER_GAIN_UBEC_OFDM_24              0x40

#define TX_POWER_GAIN_STEP_UBEC_NUM             7
#define TX_POWER_GAIN_STEP_UBEC_DENOM           10

#define RSSI_COEFF_A_2_UBEC_24                  39
#define RSSI_COEFF_A_1_UBEC_24                  -20952
#define RSSI_COEFF_A_0_UBEC_24                  -284742
#define RSSI_COEFF_C_LNA_0_UBEC_24              380000
#define RSSI_COEFF_C_LNA_1_UBEC_24              0

#define NIC_PM_WAKE_UP_TIME_UBEC                500


/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/
const NIC_MCR_CONFIG_ENTRY pauInitTableForUBEC2451_24[] = {
    {MCR_PCICR,     0x00000180},
    {MCR_PSCR,      0x39821222},
    {MCR_PPORCR0,   0x00000014},
    {MCR_PPORCR1,   0x003e003f},
    {MCR_PPDRCR0,   0x0024000a},
    {MCR_PPDRCR1,   0x00140014},
    {MCR_PPDRCR2,   0x00000050},
    {MCR_MPDR,      0x000a6c1e},
    {MCR_TNTDR,     PAU_TNTDR_UBEC_LONG_SLOT},
    {MCR_STDR,      PAU_STDR_UBEC_LONG_SLOT},
    {MCR_BGCR0,     (TX_POWER_GAIN_UBEC_CCK << 8)},
    {MCR_RFTPCR,    (TX_POWER_GAIN_UBEC_CCK | (TX_POWER_GAIN_UBEC_OFDM_24 << 8))}
};

const NIC_BBCR_CONFIG_ENTRY phyBBInitTableForUBEC2451[] = {
    {"CR1 ",  1,  0x00},
    {"CR81", 81,  0x10},
    {"CR82", 82,  0x80},
    {"CR83", 83,  0xff},
    {"CR45", 45,  0x5a},
    {"CR46", 46,  0x40},
    {"CR45", 45,  0x54},
    {"CR46", 46,  0x1d},
    {"CR45", 45,  0x55},
    {"CR46", 46,  0x1c},
    {"CR45", 45,  0x52},
    {"CR46", 46,  0x1d},
    {"CR45", 45,  0x56},
#if BB_FPGA_VERSION_TABLE
    {"CR46", 46,  0xa1},
#else
    {"CR46", 46,  0x88},
#endif
    {"CR45", 45,  0x57},
    {"CR46", 46,  0xd0},
    {"CR45", 45,  0x00},
    {"CR46", 46,  0x20},
    {"CR45", 45,  0x01},
    {"CR46", 46,  0xa2},
    {"CR45", 45,  0x02},
    {"CR46", 46,  0x40},
    {"CR45", 45,  0x03},
    {"CR46", 46,  0x23},
    {"CR45", 45,  0x04},
    {"CR46", 46,  0x33},

    {"CR49", 49,  0x04},
    {"CR50", 50,  0x84},
#if BB_FPGA_VERSION_TABLE
    {"CR77", 77,  0xe4},
#else
    {"CR77", 77,  0x70},
#endif
    {"CR45", 45,  0x4b},
    {"CR46", 46,  0x14},
    {"CR45", 45,  0x78},
    {"CR46", 46,  0x13},
    {"CR45", 45,  0x79},
    {"CR46", 46,  0x14},
    {"CR45", 45,  0x4c},
    {"CR46", 46,  0xd0},
    {"CR45", 45,  0x4d},
    {"CR46", 46,  0x04},
    {"CR45", 45,  0x5d},
    {"CR46", 46,  0x83},
    {"CR45", 45,  0x5e},
    {"CR46", 46,  0x57},
    {"CR45", 45,  0x5f},
    {"CR46", 46,  0x39},
    {"CR45", 45,  0x60},
    {"CR46", 46,  0x26},
    {"CR45", 45,  0x61},
    {"CR46", 46,  0x19},
    {"CR45", 45,  0x62},
    {"CR46", 46,  0x10},
    {"CR45", 45,  0x63},
    {"CR46", 46,  0x0a},
#if BB_FPGA_VERSION_TABLE
    {"CR45", 45,  0x64},
    {"CR46", 46,  0x49},
    {"CR45", 45,  0x65},
    {"CR46", 46,  0x66},
    {"CR45", 45,  0x66},
    {"CR46", 46,  0xe1},
    {"CR45", 45,  0x67},
    {"CR46", 46,  0xa7},
    {"CR45", 45,  0x68},
    {"CR46", 46,  0x2f},
    {"CR45", 45,  0x69},
    {"CR46", 46,  0xbf},
#else
    {"CR45", 45,  0x64},
    {"CR46", 46,  0x14},
    {"CR45", 45,  0x65},
    {"CR46", 46,  0xb3},
    {"CR45", 45,  0x66},
    {"CR46", 46,  0x50},
    {"CR45", 45,  0x67},
    {"CR46", 46,  0x51},
    {"CR45", 45,  0x68},
    {"CR46", 46,  0x97},
    {"CR45", 45,  0x69},
    {"CR46", 46,  0xe6},
#endif
    {"CR45", 45,  0x6a},
    {"CR46", 46,  0xc0},
    {"CR45", 45,  0x6b},
    {"CR46", 46,  0x51},
    {"CR45", 45,  0x6c},
    {"CR46", 46,  0x33},
    {"CR45", 45,  0x6d},
    {"CR46", 46,  0x20},
    {"CR45", 45,  0x6e},
    {"CR46", 46,  0x14},
    {"CR45", 45,  0x6f},
    {"CR46", 46,  0x0c},
    {"CR45", 45,  0x70},
    {"CR46", 46,  0x08},
    {"CR45", 45,  0x71},
    {"CR46", 46,  0x00},
    {"CR45", 45,  0x72},
    {"CR46", 46,  0x82},
    {"CR45", 45,  0x73},
    {"CR46", 46,  0xce},
    {"CR45", 45,  0x74},
    {"CR46", 46,  0x45},
    {"CR45", 45,  0x75},
    {"CR46", 46,  0x67},
    {"CR45", 45,  0x76},
    {"CR46", 46,  0x23}
};

const UINT_32 phyRFInitTableForUBEC2451_24[] = {
    0x8001E604,
    0x801103D7,
    0x8020099A,
    0x80300002,
    0x804000FF,
    0x805002FF,
    0x8001E60C,
    0x8066001B,
    0x80700000,
    0x8001E60A,
    0x8001E604
};

const UINT_32 phyRFStandbyTableForUBEC2451_24[] = {
    0x8001E60C,
    0x8001E60A,
    0x8001E604
};

const UINT_32 phyRFSleepTableForUBEC2451_24[] = {
    0x8001E600
};

const NIC_RF_CHANNEL_PROG_ENTRY phyRFChnlTableForUBEC2451_24[] = {
    { 1,    3,  { 0x801103C7, 0x80200999, 0x8001E60A } },
    { 2,    3,  { 0x801103C7, 0x8020099B, 0x8001E60A } },
    { 3,    3,  { 0x801103E7, 0x80200998, 0x8001E60A } },
    { 4,    3,  { 0x801103E7, 0x8020099A, 0x8001E60A } },
    { 5,    3,  { 0x801103E7, 0x80200999, 0x8001E60A } },
    { 6,    3,  { 0x801103E7, 0x8020099B, 0x8001E60A } },
    { 7,    3,  { 0x801103D7, 0x80200998, 0x8001E60A } },
    { 8,    3,  { 0x801103D7, 0x8020099A, 0x8001E60A } },
    { 9,    3,  { 0x801103D7, 0x80200999, 0x8001E60A } },
    { 10,   3,  { 0x801103D7, 0x8020099B, 0x8001E60A } },
    { 11,   3,  { 0x801103F7, 0x80200998, 0x8001E60A } },
    { 12,   3,  { 0x801103F7, 0x8020099A, 0x8001E60A } },
    { 13,   3,  { 0x801103F7, 0x80200999, 0x8001E60A } },
    { 14,   3,  { 0x801103CF, 0x80200CCC, 0x8001E60A } }
};

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
const ED_FLOATED_MARGIN_STRUC edFloatedMarginsForUBEC2451[ED_FLOAT_ED_LEVELS] = {
        {0x10, 0x13, 0x12},
        {0x18, 0x1a, 0x1a},
        {0x1f, 0x1f, 0x1f}
};
#endif


static
VOID
phyRFInitForUBEC2451(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFEnterActiveForUBEC2451(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFEnterSleepForUBEC2451(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFSwitchChannelForUBEC2451(IN PMP_ADAPTER adapter_p,
                              IN PNIC_RF_CHANNEL_PROG_ENTRY entry_p);

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
static
BOOLEAN
edGetFloatedMarginsForUBEC2451(IN PMP_ADAPTER adapter_p,
                               IN UINT floatLevel,
                               OUT PUINT_8 marginAGCED_p,
                               OUT PUINT_8 marginCCK_p,
                               OUT PUINT_8 marginOFDM_p);
#endif


NIC_RF_SPECIFIC_CONFIG rfConfigUBEC2451 = {
    NIC_RF_UBEC_2451,
    "UBEC UW2451",

    (PNIC_MCR_CONFIG_ENTRY) pauInitTableForUBEC2451_24,
    sizeof(pauInitTableForUBEC2451_24) / sizeof(NIC_MCR_CONFIG_ENTRY),
#if SUPPORT_802_11A
    NULL,
    0,
#endif

    PAU_TNTDR_UBEC_LONG_SLOT,
    PAU_STDR_UBEC_LONG_SLOT,

    (PNIC_BBCR_CONFIG_ENTRY) phyBBInitTableForUBEC2451,
    sizeof(phyBBInitTableForUBEC2451) / sizeof(NIC_BBCR_CONFIG_ENTRY),
    NULL,
    0,
#if SUPPORT_802_11A
    NULL,
    0,
#endif

    NULL,
    0,
#if SUPPORT_802_11A
    NULL,
    0,
#endif
    RF_INIT_WAIT_DELAY_UBEC,

    phyRFInitForUBEC2451,
    phyRFEnterActiveForUBEC2451,
    phyRFEnterSleepForUBEC2451,
    phyRFSwitchChannelForUBEC2451,
#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
    edGetFloatedMarginsForUBEC2451,
#endif

    (PNIC_RF_CHANNEL_PROG_ENTRY) phyRFChnlTableForUBEC2451_24,
    sizeof(phyRFChnlTableForUBEC2451_24) / sizeof(NIC_RF_CHANNEL_PROG_ENTRY),
#if SUPPORT_802_11A
    NULL,
    0,
#endif

    RSSI_AT_NOISE_FLOOR_BASELINE_UBEC_24,
#if SUPPORT_802_11A
    0,
#endif

    TX_POWER_GAIN_UBEC_CCK,
    TX_POWER_GAIN_UBEC_OFDM_24,
#if SUPPORT_802_11A
    0,
#endif

    TX_POWER_GAIN_STEP_UBEC_NUM,
    TX_POWER_GAIN_STEP_UBEC_DENOM,

    RSSI_COEFF_A_2_UBEC_24,
    RSSI_COEFF_A_1_UBEC_24,
    RSSI_COEFF_A_0_UBEC_24,
    RSSI_COEFF_C_LNA_0_UBEC_24,
    RSSI_COEFF_C_LNA_1_UBEC_24,
#if SUPPORT_802_11A
    0,
    0,
    0,
    0,
    0,
#endif

    NIC_PM_WAKE_UP_TIME_UBEC,

#if WORKAROUND_TXDAC_POWER_CONSUMPTION
    FALSE
#endif
};


/************************************************************************
*                       P R I V A T E   D A T A
*************************************************************************
*/
DEBUGFILE("rf_ub.c");


/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/

/*_________________________________________________________________________
**  phyRFInitForUBEC2451
**
**  descriptions: This routine is called to initialize Uniband RF chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFInitForUBEC2451(IN PMP_ADAPTER adapter_p)
{
    DEBUGFUNC("phyRFInitForUBEC2451");

    INITLOG(("\n"));

    phyWriteRFInitTable(adapter_p, (PUINT_32) phyRFInitTableForUBEC2451_24,
        sizeof(phyRFInitTableForUBEC2451_24) / sizeof(UINT_32),
        RF_INIT_WAIT_DELAY_UBEC);

}   /* phyRFInitForUBEC2451 */

/*_________________________________________________________________________
**  phyRFEnterActiveForUBEC2451
**
**  descriptions: This routine is called to let Uniband RF chipset enter RF
**                active state.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFEnterActiveForUBEC2451(IN PMP_ADAPTER adapter_p)
{

    DEBUGFUNC("phyRFEnterActiveForUBEC2451");

    DBGLOG(HW, TRACE, ("\n"));

    phyWriteRFInitTable(adapter_p, (PUINT_32) phyRFStandbyTableForUBEC2451_24,
        sizeof(phyRFStandbyTableForUBEC2451_24) / sizeof(UINT_32),
        RF_INIT_WAIT_DELAY_UBEC);
}   /* phyRFEnterActiveForUBEC2451 */

/*_________________________________________________________________________
**  phyRFEnterSleepForUBEC2451
**
**  descriptions: This routine is called to let Uniband RF chipset enter RF
**                sleep state.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFEnterSleepForUBEC2451(IN PMP_ADAPTER adapter_p)
{
    DEBUGFUNC("phyRFEnterSleepForUBEC2451");

    DBGLOG(HW, TRACE, ("\n"));

    phyWriteRFInitTable(adapter_p, (PUINT_32) phyRFSleepTableForUBEC2451_24,
        sizeof(phyRFSleepTableForUBEC2451_24) / sizeof(UINT_32), 0);
}   /* phyRFEnterSleepForUBEC2451 */

/*_________________________________________________________________________
**  phyRFSwitchChannelForUBEC2451
**
**  descriptions: This routine is called to switch channel for Uniband RF
**                chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:         (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFSwitchChannelForUBEC2451(IN PMP_ADAPTER adapter_p,
                              IN PNIC_RF_CHANNEL_PROG_ENTRY entry_p)
{
    UINT i;
    BOOLEAN status;

    DEBUGFUNC("phyRFSwitchChannelForUBEC2451");

    DBGLOG(HW, TRACE, ("\n"));

    for (i = 0; i < entry_p->numSynthProgWords; i++) {
        NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, entry_p->synthProgWords[i],
            PSPR_SYNTH_PROG_START, 2, 5, status);

        ASSERT(status);
    }

    NdisStallExecution(50);

    NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, 0x8001E604,
        PSPR_SYNTH_PROG_START, 2, 5, status);

    ASSERT(status);
}   /* phyRFSwitchChannelForUBEC2451 */

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
/*_________________________________________________________________________
**  edGetFloatedMarginsForUBEC2451
**
**  descriptions: This routine is called to get a set of floated ED margins
**                for Uniband RF chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      floatLevel - The current ED float level
**  results:
**      marginAGCED_p - Pointer to the AGC ED margin
**      marginCCK_p - Pointer to the CCK margin
**      marginOFDM_p - Pointer to the OFDM margin
**  return:
**      TRUE
**  note:
**__________________________________________________________________________*/
static
BOOLEAN
edGetFloatedMarginsForUBEC2451(IN PMP_ADAPTER adapter_p,
                               IN UINT floatLevel,
                               OUT PUINT_8 marginAGCED_p,
                               OUT PUINT_8 marginCCK_p,
                               OUT PUINT_8 marginOFDM_p)
{
    DEBUGFUNC("edGetFloatedMarginsForUBEC2451");

    DBGLOG(HW, INFO, ("\n"));

    *marginAGCED_p = edFloatedMarginsForUBEC2451[floatLevel].AGCEDMargin;
    *marginCCK_p = edFloatedMarginsForUBEC2451[floatLevel].CCKMargin;
    *marginOFDM_p = edFloatedMarginsForUBEC2451[floatLevel].OFDMMargin;

    return TRUE;
}   /* edGetFloatedMarginsForUBEC2451 */
#endif

